proc utf8 {str} {
    return [encoding convertto utf-8 [encoding convertfrom $str]]
}

proc insert {start pattern string} {
    set newstart $start.new

    if {![file exists $start]} {
        if {![catch {set fp [open $start a]}]} {
    		if {$string!=""} {
	        	puts $fp $string
   		     }
        } else {
            mess "You don't have write access to directory [file dirname $start]. Please check permissions."
            exit 1;
        }
        close $fp
        return
    } 
    if {![catch {set fpnew [open $newstart w]}]} {
        set fp [open $start r]
        set matched 0
        while {![eof $fp]} {
            set line [gets $fp]
            if {![string match $pattern $line] && ![eof $fp]} {
                puts $fpnew $line
            } else {
                if {!$matched} {
                    if {$string!=""} { 
	                    puts $fpnew $string
                    }
                    set matched 1
                }
            }
      }
      close $fp
      close $fpnew
    } else {
        mess "You don't have write access to directory [file dirname $start]. Please check permissions."
        exit 1;
    }
    catch {file rename -force $newstart $start}
}

if {$tcl_platform(os)=="Darwin" || $tcl_platform(os)=="Linux" || $tcl_platform(os)=="SunOS" } {
    set ld LD_LIBRARY_PATH
    set machine "[exec uname -s]/[exec uname -m]"
   
    if {$tcl_platform(os)=="Darwin"} {
       set ld DYLD_LIBRARY_PATH
       set machine "[exec uname -s]/[exec uname -p]"
    }

    set prefix [file join $xmllab $machine]
    set xmllab_bin [file join $prefix bin]
    set xmllab_lib [file join $prefix lib]
    if {[catch {set env(PATH)}]} {
        set env(PATH) $xmllab_bin
    } else {
        set env(PATH) $xmllab_bin:$env(PATH)
   }
   if {[catch {set env($ld)}]} {
        set env($ld) $xmllab_lib
    } else {
        set env($ld) $xmllab_lib:$env($ld)
   }

    if {$tcl_platform(os)=="Darwin"} {
	set env($ld) /usr/lib:$env($ld)
    }


   set TMPDIR [file join $env(HOME) .XMLlab cache]
   set SESSIONDIR [file join $env(HOME) .XMLlab sessions]

} elseif {$tcl_platform(os)=="Windows NT"} {
    set machine "Windows"    
    set prefix [file join $xmllab $machine]
    set xmllab_bin [file join $prefix bin]
    set xmllab_lib [file join $prefix lib]
    set env(path) "$xmllab_lib;$xmllab_bin"
    set TMPDIR [file join $env(HOME) XMLlab cache]
    set SESSIONDIR [file join $env(HOME) XMLlab sessions]
}

lappend auto_path [file join $xmllab noarch lib]

catch {file mkdir $TMPDIR}
catch {file mkdir $SESSIONDIR}

set XML_CATALOG_FILES "file:///[string map {" " "%20" "\\" "/"} $xmllab]dtd/catalog.xml"
