proc sciputs {str} {
    $::message_widget insert end "$str\n"
}

proc buildUnixScript {tclsh xmllab xmllab_bin lang SCI cmd} {
	    set f [open [file join $xmllab_bin $cmd] w]
	    puts $f "\#!/bin/bash"
	    puts $f "export xmllab=\"$xmllab\""
	    puts $f "export lang=$lang"
	    puts $f "export SCILAB=$SCI"
	    puts $f "$tclsh  \$xmllab/bin/tcl/$cmd.tcl -shell \"\$\@\""
	    close $f
	    exec chmod a+x [file join $xmllab_bin $cmd]
}

proc buildWindowsScript {tclsh xmllab xmllab_bin lang SCI cmd} {

  global env

	set f [open [file join $xmllab_bin $cmd.bat] w]
	puts $f "@echo off"
	puts $f "set lang=$lang"
	puts $f "set SCILAB=$SCI"
	puts $f "set TCL_LIBRARY=[info library]"
	puts $f "set xmllab=$xmllab"
	puts $f "$tclsh  \"%xmllab%bin\\tcl\\$cmd.tcl\" -shell %1 %2 %3 %4 %5 %6 %7 %8"
	close $f
}

proc mess { mess } {
    set reply [tk_dialog .dial "" $mess "" 0 " OK "]
}

source [file join $xmllab bin tcl env.tcl]
set ::top [toplevel .top]
wm title $::top "XMLlab installation"
image create photo mascot -file [file join $xmllab noarch images puffin.gif]
set ::message_widget [text .top.m -width 80 -height 20]
$::message_widget image create end -image mascot -align center -pady 10 -padx 10

set ::button_widget [button .top.b -text Ok -command {destroy $::top} -state disabled]
pack $::message_widget $::button_widget

sciputs "You are loading XMLlab for the first time (version $xmllab_version)\n"
sciputs "XMLlab installation folder is : $xmllab"

set fontsize 10 
option add *font {Helvetica 10  roman}
if {$tcl_platform(os)=="Windows NT"} {
    set fontsize 8
    option add *font {Helvetica 8 roman}
}

if {[catch {set xmllab}]} {
        set xmllab $env(xmllab)
}

set xmllab_escaped [string map {"\\" "/"} $xmllab]

if {$tcl_platform(os)=="Linux" || $tcl_platform(os)=="Darwin" || $tcl_platform(os)=="SunOS"} {
    catch {exec which xsltproc} xsltproc
    if {[file tail $xsltproc]!="xsltproc"} {
        sciputs "Warning : cannot find xsltproc in your path, please install libxslt and xsltproc"
    	exit 1
	}
	set ld LD_LIBRARY_PATH
	if {$tcl_platform(os)=="Darwin"} {
		set ld DYLD_LIBRARY_PATH
        	set env(PATH) /sw/bin:$env(PATH)
		set env(DYLD_LIBRARY_PATH) /sw/lib:$env(DYLD_LIBRARY_PATH)
	}

    catch {exec which tclsh} tclsh
    if {[file tail $tclsh]!="tclsh"} {
        sciputs "Warning : cannot find tclsh in your path, please install Tcl/Tk >= 8.4"
    } else {    
        sciputs "Building the XMLlab compile, pack and unpack scripts"

        buildUnixScript $tclsh $xmllab $xmllab_bin $lang $SCI xmllab
        buildUnixScript $tclsh $xmllab $xmllab_bin $lang $SCI pack
        buildUnixScript $tclsh $xmllab $xmllab_bin $lang $SCI unpack

        sciputs "Building the XMLlab helper script"

    	set f [open [file join $xmllab_bin xmllab_helper] w]
    	puts $f "\#!/bin/sh"
        puts $f "[file join $xmllab_bin xmllab] -run -helper \$1"   
    	close $f
        exec chmod a+x [file join $xmllab_bin xmllab_helper]

	    if {$tcl_platform(os)=="Darwin"} {
            set Resources  $xmllab/Darwin/noarch/bin/xmllab_helper.app/Contents/Resources
            file copy -force $Resources/launcher.sh.in $Resources/launcher.sh
		    insert $Resources/launcher.sh  "*xmllab_helper*" "PROGRAM=$xmllab_bin/xmllab_helper"
		    exec chmod a+x $Resources/launcher.sh
	    }

	    catch {exec env PATH=$env(PATH) which mogrify} mogrify
	    if {[file tail $mogrify]!="mogrify"} {
               sciputs "Warning : install ImageMagick to enable the publishing Feature"
        } else {        
	        sciputs "Building the XMLlab publishing script"
          buildUnixScript $tclsh $xmllab $xmllab_bin $lang $SCI publish
        }

	    catch {exec env PATH=$env(PATH) which vncserver} vncserver
	    catch {exec env PATH=$env(PATH) which gs} gs
        if {[file tail $vncserver]!="vncserver"} {
            sciputs "Warning : install TightVNC to enable the Web Server Feature"
            if {[file tail $gs]!="gs"} {
                sciputs "Warning : install ghostscript to enable the Web Server Feature"
            }
        } elseif {[file tail $gs]!="gs"} {
            sciputs "Warning : install ghostscript to enable the Web Server Feature"
        } else {
            sciputs "Installing the Web Server Features"
            set UserDir $env(HOME)/public_html/
            set ldpath LD_LIBRARY_PATH
        
            if {$tcl_platform(os)=="Darwin"} {
                set UserDir $env(HOME)/Sites/
                set ldpath DYLD_LIBRARY_PATH
            }

            set UserDir [tk_chooseDirectory -initialdir $UserDir -title "Give your webserver UserDir"]
            if {$UserDir != ""} {
                file mkdir $UserDir
                sciputs "Building the XMLlab Web Server CGI script"
	            set f [open [file join $xmllab webserver cgi-bin XMLlabServer.cgi] w]
	            puts $f "\#!/bin/bash"
                puts $f "export USER=$env(USER)"  
                puts $f "export REALUSER=`[exec which whoami]`"
                puts $f "export HOME=$env(HOME)"  
	        puts $f "export XMLLAB=\"$xmllab\""
                puts $f "export SCIVERSION=$SCIVERSION"
                puts $f "export SCICLICKEVENT=3"
                puts $f "export SERVERROOT=$UserDir"  
                puts $f "export CSS=xmllab.css"    
                puts $f "export DISPLAYNUMBER=99"    
                puts $f "export DISPLAY=localhost:99"
                puts $f "export XAUTHORITY=$env(HOME)/.vnc/.Xauthority"  
                puts $f "export PATH=$env(PATH)"    
                puts $f "export $ldpath=$env($ldpath)"    
	            puts $f "export lang=$lang"
                puts $f "export TK_LIBRARY=$tk_library"
                puts $f "export TCL_LIBRARY=$tcl_library"
	            puts $f "$tclsh  XMLlabServer.tcl \$\@"
	            close $f
                
                exec $xsltproc --novalid --output [file join $xmllab webserver XMLlabServer lists examples.xml]\
                        --stringparam xmllab $xmllab [file join $xmllab xsl examples.xsl]\
                        [file join $xmllab examples demos.xml]

               exec $xsltproc --novalid --output [file join $xmllab webserver XMLlabServer lists shortlist.xml]\
                        --stringparam xmllab $xmllab [file join $xmllab xsl examples.xsl]\
                        [file join $xmllab examples short.xml]


                # Create the VNC passwd 
                if {$tcl_platform(os)=="Darwin"} {
                    exec env DYLD_LIBRARY_PATH=/usr/lib /usr/X11R6/bin/xterm -T "Creating  your VNC password" -e "vncpasswd;exit"
                } else {
                    catch {exec xterm -T "Creating  your VNC password" -e "vncpasswd" } 
                }        
                                    
                # Overwrite the .vnc/xstartup user file
                
                set f [open $env(HOME)/.vnc/xstartup.turbovnc w]
	              puts $f "\#!/bin/bash"
                puts $f "twm -f $xmllab/webserver/addons/twmrc"
                close $f

	            sciputs "Installing XMLlabServer files in $UserDir"
                cd $xmllab/webserver 
                catch {exec tar cf - cgi-bin/ | tar xf - -C $UserDir} mess
                catch {exec tar cf - XMLlabServer/ | tar xf - -C $UserDir} mess

	            # g-w is a must to use the SUexec in Apache
	            sciputs "Setting permissions in $UserDir"
                exec chmod -R a+r,g-w $UserDir
                exec chmod a+x $UserDir
                exec chmod a+x $UserDir/cgi-bin
                exec chmod a+x $UserDir/cgi-bin/XMLlabServer.cgi
                cd ..
            } else {
                sciputs "Warning : the installation of XMLlab Web Server CGI script was canceled by user"

            }
         }              
     }              
    
	sciputs "Building the XML catalog"

	if {[catch {exec env $ld=$xmllab_lib \
            $xsltproc --stringparam xmllab [utf8 $xmllab]\
            --output $xmllab/dtd/catalog.xml\
			$xmllab/dtd/catalog.xsl  $xmllab/dtd/catalog.xml.in} mess]} {
		mess $mess
	}
	
            
    # installation of catalog.xml in xxe (>=2.11) config dir

    set catalogdir [file join $env(HOME) .xxe addon config] 
    catch {file mkdir $catalogdir} mess
    catch {file copy -force $xmllab/dtd/catalog.xml $catalogdir} mess

    set env(XML_CATALOG_FILES) "file:///[string map {" " "%20" "\\" "/"} $xmllab]dtd/catalog.xml"

	sciputs "Building the XMLlab menu"

	if {[catch {exec env $ld=$xmllab_lib\
        XML_CATALOG_FILES=$env(XML_CATALOG_FILES)\
		    $xsltproc --stringparam xmllab [utf8 $xmllab_escaped]\
		    --stringparam lang $lang\
		    --output tmp.xml\
		    $xmllab/xsl/xmllab_menu.xsl\
		    $xmllab/xsl/xmllab_menu.xml}]} {
		mess $mess
	}

  if {[catch {exec env $ld=$xmllab_lib\
	      $xsltproc  --output $xmllab/menu/xmllab_menu.sci\
		    $xmllab/xsl/sciml2sci.xsl\
		    tmp.xml}]} {
		mess $mess
	}

	sciputs "Building the XMLlab demos"

	if {[catch {exec env $ld=$xmllab_lib\
        XML_CATALOG_FILES=$env(XML_CATALOG_FILES)\
		    $xsltproc --stringparam xmllab [utf8 $xmllab_escaped]\
		    --stringparam lang $lang\
		    --output tmp.xml\
		    $xmllab/xsl/xmllab_demo.xsl\
		    $xmllab/examples/demos.xml}]} {
		mess $mess
	}

  if {[catch {exec env $ld=$xmllab_lib\
	      $xsltproc  --output $xmllab/demos/void.xml\
		    $xmllab/xsl/xmllab_demo_sciml2sci.xsl\
		    tmp.xml}]} {
		mess $mess
	}

    sciputs "Registering the application/x-xmllab mime type"

    # Installation of the application/x-xmllab type in .mime.types and .mailcap 

    insert [file join $env(HOME) .mime.types] "application/x-xmllab*" "application/x-xmllab xmllab"
    insert [file join $env(HOME) .mailcap] "application/x-xmllab*" "application/x-xmllab; [file join $xmllab_bin xmllab_helper] %s"

    sciputs "\nInstallation complete, click OK to return to Scilab prompt."

    $::button_widget configure -state normal  
    tkwait window $::top 
    file delete tmp.xml

} elseif {$tcl_platform(os)=="Windows NT"} {

    set xsltproc [file join $xmllab_bin xsltproc]

	sciputs "Building the XMLlab compile, pack and unpack scripts"

    set tclsh [file join $xmllab_bin tclsh]
    if {$::tcl_version == "8.5"} {
      set tclsh [file join $xmllab_bin tclsh85]
    }
	buildWindowsScript $tclsh $xmllab $xmllab_bin $lang $SCI xmllab
	buildWindowsScript $tclsh $xmllab $xmllab_bin $lang $SCI pack
	buildWindowsScript $tclsh $xmllab $xmllab_bin $lang $SCI unpack

	sciputs "Building the XMLlab helper script"

	set f [open [file join $xmllab_bin xmllab_helper.bat] w]
	puts $f "@echo off"
	puts $f "set PATH=$xmllab_bin;%PATH%"
	puts $f "xmllab -helper -run %1"
	close $f

	sciputs "Building the XML catalog"
	set env(path) $xmllab_lib

	if [catch {exec $xsltproc --stringparam xmllab "/$xmllab"\
		        --output $xmllab/dtd/catalog.xml\
				$xmllab/dtd/catalog.xsl $xmllab/dtd/catalog.xml.in} mess] {
		mess $mess
		exit 1
	}

    # installation of catalog.xml in xxe (>= 2.11) config dir

    set catalogdir [file join $env(HOME) "AppData" XMLmind XMLeditor addon config]
    file mkdir $catalogdir
    file copy -force $xmllab/dtd/catalog.xml $catalogdir

	set env(XML_CATALOG_FILES) "file:///[string map {" " "%20" "\\" "/"} $xmllab]dtd/catalog.xml"

	sciputs "Building the XMLlab menu"

	catch {exec $xsltproc --stringparam type admin --stringparam xmllab [utf8 $xmllab_escaped]\
		    --stringparam lang $lang\
		    --output tmp.xml\
		    $xmllab/xsl/xmllab_menu.xsl\
		    $xmllab/xsl/xmllab_menu.xml} mess

	catch {exec $xsltproc --output $xmllab/menu/xmllab_menu.sci\
		    $xmllab/xsl/sciml2sci.xsl\
		    tmp.xml} mess

	catch {exec $xsltproc --stringparam type user --stringparam xmllab [utf8 $xmllab_escaped]\
		    --stringparam lang $lang\
		    --output tmp.xml\
		    $xmllab/xsl/xmllab_menu.xsl\
		    $xmllab/examples/demos.xml} mess

	sciputs "Building the XMLlab demos"

	catch {exec $xsltproc --stringparam xmllab [utf8 $xmllab_escaped]\
		    --stringparam lang $lang\
		    --output tmp.xml\
		    $xmllab/xsl/xmllab_demo.xsl\
		    $xmllab/examples/demos.xml} mess

	catch {exec $xsltproc --output $xmllab/demos/void.xml\
		    $xmllab/xsl/xmllab_demo_sciml2sci.xsl\
		    tmp.xml} mess

    sciputs "Creating installation registry key"

    package require registry
    
    set xmllab_helper "\"[file join $xmllab_bin xmllab_helper.bat]\" \"%1\""
    
    if {[catch {registry set {HKEY_CURRENT_USER\Software\Classes\.xmllab} "" "xmllab_auto_file"} err_msg]} {
		mess $err_msg
	} else {
	    catch {registry set {HKEY_CURRENT_USER\Software\Classes\.xmllab} "Content Type" "application/x-xmllab"}
    	catch {registry set {HKEY_CURRENT_USER\Software\Classes\xmllab_auto_file\shell\open\command} "" [string map {"/" "\\" } $xmllab_helper]}
    	catch {registry set {HKEY_CURRENT_USER\Software\Classes\xmllab_auto_file\DefaultIcon} "" "[string map {/ \\} [file join $xmllab noarch images xmllab.ico]],0"}
	}

  sciputs "\nInstallation complete, click OK to restart Scilab"

  $::button_widget configure -state normal  
  tkwait window $::top 
  file delete tmp.xml

}




