function [b]=fsol(alpha)

M=length(alpha);
b=zeros(M,1);
n=(2*(1:M)+1)';
for k=1:M
   b=b+(-1)^k*cos(n*alpha(k));
end
b=(1+2*b)*4/%pi./n;

//****************************************************************************
endfunction

function [J]=fsolj(alpha)

M=length(alpha);
J=zeros(M,M);
k=1:M
for p=1:M
   J(p,:)=-8/%pi*((-1).^k).*sin((2*p+1)*alpha');
end

//****************************************************************************
endfunction

function [b]=coeffour(alpha,p)

M=length(alpha);
b=zeros(p);

n=(2*p+1);

for k=1:M
   b=b+(-1)^k*cos(n*alpha(k));
end

b=(1+2*b)*4/%pi./n;
endfunction

//****************************************************************************

function f=fonde(alpha,t)

alpha=-gsort(-alpha);

s1=sign(t);

t=abs(modulo(t,2*%pi));

s2=sign(%pi-t);

t(t > %pi) = 2*%pi-t(t > %pi);
t(t > %pi/2) = %pi-t(t > %pi/2);

alpha=[0;alpha;%pi/2];

M=length(alpha);

f=zeros(t);

for i=1:M-1
   f( (t>=alpha(i) & t<alpha(i+1)) )=(-1)^(i-1);
end

f=f.*s1.*s2;
endfunction

//****************************************************************************

function f=sommePart(b,t)

N=length(b);
p=0:N-1;

f=sin(t*(2*p+1))*b;

endfunction
   
