function [A,b]=assembRobinCnd(bdy,x,y,sigma,xi)

	// Matrice et vecteur pour une condition
	// aux limites de Robin, 
	//
	// p*du/dn + sigma*u = xi

	nNodes=length(x);
	nElemBnd=size(bdy,2);

	ind=zeros(4*nElemBnd,2);
    k=1;
	for i=1:nElemBnd
    	[ii,jj]=meshgrid(bdy(:,i),bdy(:,i));
    	ind(k:k+4-1,1)=matrix(ii,4,1);
    	ind(k:k+4-1,2)=matrix(jj,4,1);
        k=k+4;
    end
    A=sparse(ind,%eps*ones(4*nElemBnd,1),[nNodes,nNodes]);

	b=zeros(nNodes,1); 

	phi=shapeTriBnd(u_Gauss1D);

	for i=1:size(bdy,2);

		nodes=bdy(:,i);
		xloc=x(nodes); yloc=y(nodes);
		xgauss=(xloc(1)+xloc(2))/2+(xloc(2)-xloc(1))/2*u_Gauss1D;
		ygauss=(yloc(1)+yloc(2))/2+(yloc(2)-yloc(1))/2*u_Gauss1D;
		Ls2=sqrt((xloc(2)-xloc(1))^2+(yloc(2)-yloc(1))^2)/2;
    
	    if typeof(sigma)=='function'
			sigmaTilde=sigma(xgauss,ygauss);
			Ae=phi*diag(w_Gauss1D.*sigmaTilde)*phi';
		else
			Ae=sigma*phi*diag(w_Gauss1D)*phi';
		end

		if typeof(xi)=='function'
			xiTilde=xi(xgauss,ygauss);
			be=phi*(w_Gauss1D.*xiTilde)';
		else
			be=xi*phi*(w_Gauss1D)';
		end

		A(nodes,nodes)=A(nodes,nodes)+Ae*Ls2;
		b(nodes)=b(nodes)+be*Ls2;

	end

endfunction
