function [A,b]=assemblyBdy(prob)

	// Assemblage des conditions aux limites sur
	// la frontire du domaine dcrit dans prob.dom

	u_Gauss1D=[-sqrt(3)/3 sqrt(3)/3];
	w_Gauss1D=[1 1];  

	BIG=1e100;

	nElem=prob.domain.elements;
	nNodes=prob.domain.nodes;

	A=spzeros(nNodes,nNodes);
	b=zeros(nNodes,1);

	for i=1:length(prob.bdycond)
		select prob.bdycond(i).type
		case 'robin'
			[Ar,br]=assembRobinCnd(prob.domain.sides(i),...
									prob.domain.x,...
									prob.domain.y,...
									prob.bdycond(i).sigma,...
									prob.bdycond(i).xi);
			A=A+Ar;b=b+br;
		case 'dirichlet'
			[Ad,bd]=assembRobinCnd(prob.domain.sides(i),...
									prob.domain.x,...
									prob.domain.y,...
									1,...
									prob.bdycond(i).g);
			A=A+BIG*Ad; b=b+BIG*bd;
		end
	end

endfunction
