function [A,b,Mass]=assemblyDom(prob)

	// Assemblage des matrices lmentaires
	// correspondant aux intgrales dans l'intrieur du
	// domaine prob.dom (pour les frontires voir assemblyBdy).
	
	xi_Gauss2D=[.5 .5 0];
	eta_Gauss2D=[0 .5 .5];
	w_Gauss2D=[1/6 1/6 1/6];

	nElem=prob.domain.elements;
	nNodes=prob.domain.nodes;

//	timer()

	ind=zeros(9*nElem,2);
    k=1;
    tri=prob.domain.tri;
	for i=1:nElem
    	[ii,jj]=meshgrid(tri(:,i),tri(:,i));
    	ind(k:k+9-1,1)=matrix(ii,9,1);
    	ind(k:k+9-1,2)=matrix(jj,9,1);
        k=k+9;
    end
    A=sparse(ind,%eps*ones(9*nElem,1),[nNodes,nNodes]);
	Mass=sparse(A);	

	b=zeros(nNodes,1);

	phi=shapeTri(xi_Gauss2D,eta_Gauss2D);
	gTilde=gradShapeTri();

	for k=1:nElem
		nodesTri=prob.domain.tri(:,k);
		x=prob.domain.x(nodesTri);
		y=prob.domain.y(nodesTri);
		[Ae,be,Me]=elemTri(x,y,prob.diffusion,prob.proportional,prob.source,prob.transport);
		A(nodesTri,nodesTri)=A(nodesTri,nodesTri)+Ae;
		Mass(nodesTri,nodesTri)=Mass(nodesTri,nodesTri)+Me;
		b(nodesTri)=b(nodesTri)+be;
	end
//    disp(timer())

endfunction
