function [_value,_ierr,_errtext]=check_scalar(_label,_name,_min_string,_max_string,_scale_string)
_ierr=0;
_errtext="";
_value=0;
if execstr('_value_string=TCL_GetVar(_label)','errcatch');
	_value_string=[];
end

[_value,_ierr]=evstr(_value_string);
if _ierr
	_value=0;
	[_errtext,_n,_line,_func]=lasterror();	
	_errtext="Value of "+_label+" is not understood by Scilab : "+_errtext;
	return
end
if _value==[]
	_value=0;
end

[_min,_ierr]=evstr(_min_string);
if _ierr
	[_errtext,_n,_line,_func]=lasterror();	
	_errtext="Attribute min="+_min_string+" of "+_label+" is not understood by Scilab : "+_errtext;
	return
end

[_max,_ierr]=evstr(_max_string);
if _ierr
	[_errtext,_n,_line,_func]=lasterror();	
	_errtext="Attribute max="+_max_string+" of "+_label+" is not understood by Scilab : "+_errtext;
	return
end


[_scale,_ierr]=evstr(_scale_string);
if _ierr
	[_errtext,_n,_line,_func]=lasterror();	
	_errtext="Attribute scale="+_scale_string+" of "+_label+" is not understood by Scilab : "+_errtext;
	return
end

if _value>=_min
	if _value<=_max
		[_value,_ierr]=evstr("_value*_scale");
		return;
	else
		_ierr=1;
		_errtext=_name+" must be smaller than "+_max_string;
	end
else
	_ierr=1
	_errtext=_name+" must be greater than "+_min_string;
end

endfunction
