function [Ae,be,Me]=elemTri(x,y,p,c,f,v)

	// Matrices et vecteur lmentaires pour le problme
	//
	// -div(p*u)+c*u+v.grad(u)=f, 
	//
	// + condition de Neuman Homogne
	//
	// Ae : matrice de "raideur"
	// Me : matrice de "Masse"
	// be : vecteur lmentaire
	//
	// Interpolation linaire

	D=[x(2)-x(1) x(3)-x(1);y(2)-y(1) y(3)-y(1)];
	C=[x(1);y(1)];

	detD=det(D);

	ptGauss2D=D*[xi_Gauss2D;eta_Gauss2D];
	ptGauss2D(1,:)=ptGauss2D(1,:)+C(1);
	ptGauss2D(2,:)=ptGauss2D(2,:)+C(2);

//	for k=1:length(w_Gauss2D)
//		Ae=Ae+w_Gauss2D(k)*cTilde(k)*phi(:,k)*phi(:,k)';
//		Me=Me+w_Gauss2D(k)*phi(:,k)*phi(:,k)';
//		be=be+w_Gauss2D(k)*fTilde(k)*phi(:,k);
//	end

	// La mme chose que ci-dessus en plus rapide

	g=(D')\gTilde;

	if typeof(c)=='function'
		cTilde=c(ptGauss2D(1,:),ptGauss2D(2,:));
	else
		cTilde=c;
	end
	if typeof(f)=='function'
		fTilde=f(ptGauss2D(1,:),ptGauss2D(2,:));
	else
		fTilde=f;
	end

	Ae=phi*diag(w_Gauss2D.*cTilde)*phi'+phi*diag(w_Gauss2D)*[v v v]'*g;
	Me=phi*diag(w_Gauss2D)*phi';
	be=phi*(w_Gauss2D.*fTilde)';

    if typeof(p)=='function'
	  	pTilde=p(ptGauss2D(1,:),ptGauss2D(2,:));
    	Ae=Ae+w_Gauss2D*pTilde'*g'*g;
	else
		Ae=Ae+.5*g'*p*g;
	end

	Ae=Ae*detD; Me=Me*detD; be=be*detD;
 
endfunction
