function prob=fem_newproblem(dom)

	// Cration d'une variable de type 'problem' dcrivant le probleme
	//
	// -div(p*grad(u)) + c*u + v.grad(u) = f
	//
	// On initialise le champ 'domain' avec le domaine
	// pass en paramtre. p est initialis  1 ainsi
	// que c et f  0.
	// p,c,f peuvent etre des fonctions. Dans ce cas elles doivent
	// avoir une definition du genre :
	//
	// function z=fun(x,y)
	// ...
	// endfunction
	//
	// et doivent accepter des arguments vectoriels.
	//
	// Par dfaut, les conditions aux limites sont de type 'none'
	// ce qui est  interprter comme 'Neuman homogne'.

	prob=tlist(['problem';'domain';'diffusion';'proportional';'source';'transport';'bdycond';'mass']);
	prob.domain=dom;
	prob.diffusion=1;
	prob.proportional=0;
	prob.source=0;
	prob.transport=[0;0];
	prob.bdycond=list();
	prob.mass=[];

	for i=1:length(dom.sides)  
		prob.bdycond(i)=tlist(['bdycond';'type';'sigma';'xi';'g'],'none',0,[],[]);
	end
	
	//
	// Voir le fichier 'exemple.sci' pour un exemple
	// de probleme.
	
endfunction
