<?xml version="1.0" encoding="ISO-8859-1"?>

<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform">

<xsl:param name="file"/>

<xsl:output method="xml" indent="yes" encoding="ISO-8859-1" doctype-public="-//UTC//DTD XMLlab V1.3//FR" 
						doctype-system="http://www.xmllab.org/dtd/1.3/simulation.dtd"/>

<xsl:template match="/">
	<xsl:message>******************************************************************</xsl:message>
	<xsl:message>Warning : you are processing an old version (1.2) simulation file.</xsl:message>
	<xsl:message>Old file will be written to : <xsl:value-of select="concat($file,'.xml.1.2')"/></xsl:message>
	<xsl:message>******************************************************************</xsl:message>	
    <xsl:apply-templates mode="convert"/>
</xsl:template>

<xsl:template match="simulation" mode="convert">
	<simulation>
		<xsl:apply-templates mode="convert"/>
	</simulation>
</xsl:template>

<xsl:template match="*|@*|text()|comment()" mode="convert">
        <xsl:copy>
            <xsl:apply-templates select="*|@*|text()|comment()|processing-instruction()" mode="convert"/>
        </xsl:copy>
</xsl:template>

<xsl:template match="polyline" mode="convert">
	<polyline label="{@label}">
		<xsl:apply-templates mode="convert"/>
	</polyline>
</xsl:template>

<xsl:template match="point" mode="convert">
	<vertex x1="{px1}" x2="{px2}">
		<xsl:copy-of select="name"/>
	</vertex>
</xsl:template>

</xsl:stylesheet>
