<?xml version="1.0" encoding="ISO-8859-1"?>

<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform">
<xsl:param name="file"/>
<xsl:param name="web"/>
<xsl:param name="publicid"/>
<xsl:param name="systemuri"/>

<xsl:template match="/">
    <xsl:if test="$web='no'">
    	<xsl:message>******************************************************************</xsl:message>
	    <xsl:message>Warning : you are processing an old version (1.4) simulation file.</xsl:message>
    	<xsl:message>Old file will be written to : <xsl:value-of select="concat($file,'.xml.1.4')"/></xsl:message>
    	<xsl:message>******************************************************************</xsl:message>
    </xsl:if>
    <xsl:apply-templates mode="convert"/>
</xsl:template>

<xsl:template match="simulation" mode="convert">
    <xsl:document href="{$file}-converted.xml"
                      doctype-public="{$publicid}"
                      doctype-system="{$systemuri}"
                      encoding="ISO-8859-1"
                      indent="yes">
	    <simulation>
		    <xsl:apply-templates mode="convert" select="header|notes|image"/>
		    <parameters>
			    <xsl:apply-templates mode="convert" select="parameters"/>
		    </parameters>
		    <xsl:apply-templates mode="convert" select="script|compute"/>
            <xsl:apply-templates mode="graphs" select="compute"/>
		    <xsl:apply-templates mode="convert" select="display|save"/>
	    </simulation>
    </xsl:document>
</xsl:template>

<xsl:template match="*|@*|text()|comment()" mode="convert">
        <xsl:copy>
            <xsl:apply-templates select="*|@*|text()|comment()|processing-instruction()" mode="convert"/>
        </xsl:copy>
</xsl:template>

<xsl:template match="parameters" mode="convert">
	<xsl:apply-templates mode="convert"/>
    <xsl:apply-templates select="../actions" mode="convert"/>
</xsl:template>

<xsl:template match="compute" mode="convert">
	<compute>
        <xsl:apply-templates select="defdomain1d|defdomain2d|ode|implicitfunction|stationary-pde" mode="convert"/>
    </compute>
</xsl:template>

<xsl:template match="compute" mode="graphs">
    <graphs>
    	<xsl:apply-templates select="nonparametriccurve2d|parametriccurve2d|parametriccurve3d|nonparametricsurface|parametricsurface|polyline" mode="convert"/>
    </graphs>
</xsl:template>


</xsl:stylesheet>
