<?xml version="1.0" encoding="ISO-8859-1"?>

<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform">
<xsl:param name="file"/>
<xsl:param name="web"/>
<xsl:param name="publicid"/>
<xsl:param name="systemuri"/>

<xsl:template match="/">
    <xsl:if test="$web='no'">
    	<xsl:message>******************************************************************</xsl:message>
	    <xsl:message>Warning : you are processing an old version (1.5) simulation file.</xsl:message>
    	<xsl:message>Old file will be written to : <xsl:value-of select="concat($file,'.xml.1.5')"/></xsl:message>
    	<xsl:message>******************************************************************</xsl:message>
    </xsl:if>
    <xsl:apply-templates mode="convert"/>
</xsl:template>

<xsl:template match="simulation" mode="convert">
    <xsl:document href="{$file}-converted.xml"
                      doctype-public="{$publicid}"
                      doctype-system="{$systemuri}"
                      encoding="ISO-8859-1"
                      indent="yes">
	    <simulation>
		    <xsl:apply-templates mode="convert"/>
 	    </simulation>
    </xsl:document>
</xsl:template>

<xsl:template match="*|@*|text()|comment()" mode="convert">
        <xsl:copy>
            <xsl:apply-templates select="*|@*|text()|comment()|processing-instruction()" mode="convert"/>
        </xsl:copy>
</xsl:template>


<xsl:template match="scalar" mode="convert">
	<scalar>
		<xsl:copy-of select="@*[not(self::widget)]"/>
		<xsl:choose>
			<xsl:when test="@widget='animate'">
				<xsl:if test="not(@period)">
					<xsl:attribute name="period">100</xsl:attribute>
				</xsl:if>
				<xsl:if test="not(@increment)">
					<xsl:attribute name="increment">
						<xsl:value-of select="((@min)-(@max)) div 100"/>
					</xsl:attribute>
				</xsl:if>
			</xsl:when>
			<xsl:when test="@widget='slider'">
				<xsl:if test="not(@increment)">
					<xsl:attribute name="increment">
						<xsl:value-of select="((@min)-(@max)) div 100"/>
					</xsl:attribute>
				</xsl:if>
			</xsl:when>
			<xsl:when test="@widget='hidden'">
					<xsl:attribute name="state">hidden</xsl:attribute>
			</xsl:when>
		</xsl:choose>
		<xsl:copy-of select="*"/>
	</scalar>
</xsl:template>

<xsl:template match="@tearoff" mode="convert"/>
<xsl:template match="@widget" mode="convert"/>

<xsl:template match="point" mode="convert">
	<point>
		<xsl:copy-of select="@*[not(self::widget)]"/>
		<xsl:choose>
			<xsl:when test="@widget='hidden'">
					<xsl:attribute name="state">hidden</xsl:attribute>
			</xsl:when>
		</xsl:choose>
		<xsl:copy-of select="*"/>
	</point>
</xsl:template>


</xsl:stylesheet>
