<?xml version="1.0" encoding="ISO-8859-1"?>

<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform">

<xsl:output doctype-public="-//UTC//DTD ScilabXML V1.1//FR" doctype-system="http://www.scilabxml.org/dtd/1.1/simulation.dtd" method="xml" indent="yes" encoding="ISO-8859-1"/>

<xsl:template match="/">
	<xsl:if test="not(simulation)">
		<xsl:message terminate="yes">
			<xsl:text>Le fichier  convertir n'est pas une simulation ScilabXML.</xsl:text>
		</xsl:message>
	</xsl:if>
	<xsl:apply-templates />
</xsl:template>

<xsl:template match="parameters[last()]">
	<xsl:element name="parameters">
		<xsl:apply-templates/>
	</xsl:element>
	<xsl:for-each select="//compute/user-parametriccurve2d">
		<parameters>
			<title><xsl:value-of select="name"/></title>
			<matrix cols="2" rows="64" label="{@label}_mat" striprow="yes" clear="yes" save="yes" load="yes">
				<name/>
				<col>
					<xsl:copy-of select="x1/name"/>
					<xsl:copy-of select="x1/value"/>
				</col>
				<col>
					<xsl:copy-of select="x2/name"/>
					<xsl:copy-of select="x2/value"/>
				</col>
			</matrix>
		</parameters>
	</xsl:for-each>
</xsl:template>

<xsl:template match="parameter">
	<xsl:element name="scalar">
		<xsl:copy-of select="*|@*"/>
	</xsl:element>
</xsl:template>

<xsl:template match="record-value">
	<xsl:element name="scalar-value">
		<xsl:copy-of select="*|@*|text()"/>
	</xsl:element>
</xsl:template>

<xsl:template match="compute/user-parametriccurve2d">
	<parametriccurve2d label="{@label}">
		<xsl:copy-of select="name"/>
		<x1>
			<xsl:copy-of select="x1/name"/>
			<value><xsl:value-of select="@label"/>_mat(:,1)</value>
		</x1>
		<x2>
			<xsl:copy-of select="x2/name"/>	
			<value><xsl:value-of select="@label"/>_mat(:,2)</value>
		</x2>
	</parametriccurve2d>
</xsl:template>


<xsl:template match="*|@*|text()|comment()">
        <xsl:copy>
            <xsl:apply-templates select="*|@*|text()|comment()|processing-instruction()"/>
        </xsl:copy>
</xsl:template>


</xsl:stylesheet>
