<?xml version="1.0" encoding="ISO-8859-1"?>

<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform">
<xsl:param name="outputfile"/>
<xsl:param name="web"/>
<xsl:param name="publicid"/>
<xsl:param name="systemuri"/>

<xsl:output method="xml" indent="yes" encoding="ISO-8859-1"/>

<xsl:template match="/">
    <xsl:document href="{$outputfile}"
                      doctype-public="{$publicid}"
                      doctype-system="{$systemuri}"
                      encoding="ISO-8859-1"
                      indent="yes">
		    <xsl:apply-templates/>
    </xsl:document>
</xsl:template>

<xsl:template match="*|@*|text()|comment()">
        <xsl:copy>
            <xsl:apply-templates select="*|@*|text()|comment()|processing-instruction()"/>
        </xsl:copy>
</xsl:template>

<xsl:template match="resource">
    <resource href="{@href}" type="{@type}" encoding="base64">
        <xsl:value-of select="document('resource.xml',/)/resources/resource[@href=current()/@href]"/>
    </resource>
</xsl:template>

<xsl:template match="image">
    <image href="{@href}" encoding="base64">
        <xsl:value-of select="document('resource.xml',/)/resources/resource[@href=current()/@href]"/>
    </image>
</xsl:template>

<xsl:template match="script[@href]">
    <script href="{@href}" encoding="base64">
        <xsl:value-of select="document('resource.xml',/)/resources/resource[@href=current()/@href]"/>
    </script>
</xsl:template>

</xsl:stylesheet>
