<?xml version="1.0"?>

<xsl:stylesheet version="1.0" 
    xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
    xmlns:str="http://exslt.org/strings"
   xmlns:tcl="http://xmllab.org/Tcl" 
   xmlns:exslt="http://exslt.org/common">

<xsl:strip-space elements="*"/>

<xsl:include href="xml2tkml.xsl"/>
<xsl:include href="tkml2tk.xsl"/>

<xsl:output method="text"/>

<xsl:template match="/">
    <xsl:variable name="tkml">
        <tkml>
		<xsl:apply-templates/>
	</tkml>
    </xsl:variable>
    <xsl:apply-templates select="exslt:node-set($tkml)/tkml//set"/>
</xsl:template>

<xsl:template match="session">
    <xsl:apply-templates/>
</xsl:template>

<xsl:template match="header"/>

<xsl:template match="data">
    <xsl:apply-templates/>
</xsl:template>

<xsl:template match="scalar">
	<set variable="::{@label}" value="{@value}"/>
</xsl:template>

<xsl:template match="matrix">
	<xsl:variable name="label" select="@label"/>
	<xsl:for-each select="row">
		<xsl:variable name="i" select="position()"/>
		<xsl:for-each select="str:split(translate(translate(.,'{}','  '),' ',','),',')">
		 	<set variable="::{$label}({$i},{position()})" value="{.}"/>
		</xsl:for-each>
	</xsl:for-each>
</xsl:template>

<xsl:template match="database">
	<set variable="::{concat(@label,'_index')}" value="{@index}"/>
</xsl:template>
    
</xsl:stylesheet>

