<?xml version="1.0" encoding="ISO-8859-1"?>

<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform">
<xsl:output method="xml" indent="yes" encoding="ISO-8859-1" doctype-public="-//UTC//DTD XMLlab V1.4L//FR" 
						doctype-system="http://www.xmllab.org/dtd/1.4L/simulation.dtd"/>

<xsl:param name="workdir"/>
<xsl:strip-space elements="*"/>
<xsl:variable name="lang" select="document('modify.xml',/)/modify/@lang"/>

<xsl:template match="/">
	<xsl:apply-templates/>
</xsl:template>

<xsl:template match="*|@*|text()|comment()">
        <xsl:copy>
            <xsl:apply-templates select="*|@*|text()|comment()|processing-instruction()"/>
        </xsl:copy>
</xsl:template>

<xsl:template match="database[@label=document('modify.xml',/)/modify[@action='add']/@database]">
	<database>
		<xsl:apply-templates select="@*"/>
		<xsl:apply-templates select="title"/>
		<xsl:apply-templates select="*[not(self::record)]"/>
		<xsl:apply-templates select="record[name[(@lang=$lang) or (not(@lang))] != document('modify.xml',/)/modify[@action='add']/@record]"/>
		<record>
			<name lang="{$lang}"><xsl:value-of select="document('modify.xml',/)/modify/@record"/></name>
			<xsl:apply-templates select="document('modify.xml',/)/modify/*"/>
		</record>
	</database>	
</xsl:template>

<xsl:template match="row[string-length(normalize-space(value))=0]"/>

<xsl:template match="database[@label=document('modify.xml',/)/modify[@action='delete']/@database]">
	<database>
		<xsl:apply-templates select="@*"/>
		<xsl:apply-templates select="title"/>
		<xsl:apply-templates select="*[not(self::record)]"/>
		<xsl:apply-templates select="record[name[(@lang=$lang) or (not(@lang))] != document('modify.xml',/)/modify[@action='delete']/@record]"/>
	</database>	
</xsl:template>

<xsl:template match="database[@label=document('modify.xml',/)/modify[@action='makedefault']/@database]">
	<database>
		<xsl:apply-templates select="@*"/>
		<xsl:apply-templates select="title"/>
		<xsl:apply-templates select="*[not(self::record)]"/>
		<xsl:apply-templates select="record[name[(@lang=$lang) or (not(@lang))] = document('modify.xml',/)/modify[@action='makedefault']/@record]"/>
		<xsl:apply-templates select="record[name[(@lang=$lang) or (not(@lang))] != document('modify.xml',/)/modify[@action='makedefault']/@record]"/>		
	</database>	
</xsl:template>


</xsl:stylesheet>
