<?xml version="1.0" encoding="ISO-8859-1"?>
<xsl:stylesheet 
    xmlns:exslt="http://exslt.org/common" 
    xmlns:str="http://exslt.org/strings" 
    xmlns:xsl="http://www.w3.org/1999/XSL/Transform" 
    version="1.0" 
    exclude-result-prefixes="exslt str">

  <xsl:output method="xml" indent="no" encoding="ISO-8859-1"/>
  <xsl:strip-space elements="*"/>

  <xsl:param name="xmllab"/>

  <xsl:param name="file"/>
  <xsl:param name="outputname"/>
  <xsl:param name="outputdir"/>
  <xsl:param name="sourcename"/>
  <xsl:param name="dirname"/>

  <xsl:param name="utf8file"/>
  <xsl:param name="utf8outputname"/>
  <xsl:param name="utf8outputdir"/>
  <xsl:param name="utf8sourcename"/>
  <xsl:param name="utf8dirname"/>

  <xsl:param name="shell"/>
  <xsl:param name="web"/>
  <xsl:param name="images"/>
  <xsl:param name="webimages"/>
  <xsl:param name="scriptname"/>
  <xsl:param name="logfile"/>
  <xsl:param name="referer"/>

  <xsl:param name="os"/>
  <xsl:param name="language">DEFAULT</xsl:param>
  <xsl:param name="screenshots"/>
  <xsl:param name="appname"/>
  <xsl:param name="mastername"/>
  <xsl:param name="havesource"/>
  <xsl:param name="timing"/>
  <xsl:param name="widget">plain</xsl:param>

  <xsl:variable name="lang">
  	<xsl:choose>
    	<xsl:when test="$language='DEFAULT'">
        	<xsl:value-of select="/simulation/@default-lang"/>
        </xsl:when>
        <xsl:otherwise>
        	<xsl:value-of select="$language"/>
        </xsl:otherwise>
    </xsl:choose>
  </xsl:variable>

  <xsl:include href="localization.xsl"/>
  <xsl:include href="xml2sciml.xsl"/>
  <xsl:include href="xml2tkml.xsl"/>

  <xsl:key name="subsections" match="subsection|database" use="@label"/>
  <xsl:key name="matrices" match="matrix" use="@label"/>
  <xsl:key name="scalars" match="scalar" use="@label"/>
  <xsl:key name="graphs" match="polyline|parametriccurve2d|nonparametriccurve2d|parametricsurface|nonparametricsurface|state|unknown|output" use="@label"/>

  <xsl:template match="/">

        <xsl:document href="{concat($outputname,'.sciml')}" method="xml" indent="yes" encoding="UTF-8">
 
        	<xsl:apply-templates mode="sciml"/>
 
        </xsl:document>
  
        <xsl:document href="{concat($outputname,'.tkml')}"  method="xml" indent="yes" encoding="UTF-8">
 
            <xsl:choose>
	 	        <xsl:when test="$web='yes'">
		            <xsl:apply-templates mode="web"/>
	            </xsl:when>
		        <xsl:otherwise>
	    	        <xsl:apply-templates mode="tkml"/>
		        </xsl:otherwise>
	        </xsl:choose>		       
 
        </xsl:document>
  
  </xsl:template>

</xsl:stylesheet>
