<?xml version="1.0"?>

<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform">

<xsl:output method="xml" indent="no" encoding="ISO-8859-1"/>

<xsl:strip-space elements="*"/>

<!-- Generation of code for surfaces -->


<xsl:template match="nonparametricsurface" mode="script">
	<xsl:apply-templates mode="script"/>	
</xsl:template>

<xsl:template match="nonparametricsurface">
	<xsl:apply-templates mode="script"/>	
</xsl:template>


<xsl:template match="nonparametricsurface" mode="plot">
	<xsl:apply-templates mode="plot"/>
</xsl:template>

<xsl:template match="parametricsurface" mode="script">
	<xsl:apply-templates mode="script"/>	
</xsl:template>

<xsl:template match="parametricsurface">
	<xsl:apply-templates mode="script"/>	
</xsl:template>


<xsl:template match="parametricsurface" mode="plot">
	<xsl:apply-templates select="x1|x2|x3" mode="plot"/>
</xsl:template>

<xsl:template match="parametricsurface" mode="labels3d">
	<parm><string>xlabel</string></parm>
	<parm><string>
		<xsl:value-of select='normalize-space(x1/name[(@lang=$lang) or (not(@lang))])'/>
	</string></parm>
	<parm><string>ylabel</string></parm>
	<parm><string>
		<xsl:value-of select='normalize-space(x2/name[(@lang=$lang) or (not(@lang))])'/>
	</string></parm>
	<parm><string>zlabel</string></parm>
	<parm><string>
		<xsl:value-of select='normalize-space(x3/name[(@lang=$lang) or (not(@lang))])'/>
	</string></parm>
</xsl:template>

<xsl:template match="nonparametricsurface" mode="labels2d">
	<xsl:apply-templates select="refdomain2d|defdomain2d" mode="labels"/>
    <parm><string>title</string></parm>
	<parm>
      <string>
        <xsl:choose>
            <xsl:when test="name">
			    <xsl:value-of select="normalize-space(name[(@lang=$lang) or (not(@lang))])"/>
            </xsl:when>
            <xsl:otherwise>
                <xsl:value-of select="normalize-space(x3/name[(@lang=$lang) or (not(@lang))])"/>
            </xsl:otherwise>
        </xsl:choose>
       </string>
	</parm>
</xsl:template>

<xsl:template match="nonparametricsurface" mode="labels3d">
	<xsl:apply-templates select="refdomain2d|defdomain2d" mode="labels"/>
    <parm>
		<string>zlabel</string>
	</parm>	
    <parm>
		<string>
			<xsl:value-of select="normalize-space(x3/name[(@lang=$lang) or (not(@lang))])"/>
		</string>
	</parm>
    <parm>
        <string>title</string></parm>
	<parm>
		<string>
			<xsl:value-of select="normalize-space(name[(@lang=$lang) or (not(@lang))])"/>
		</string>
	</parm>    
</xsl:template>


<xsl:template match="nonparametricsurface" mode="functions"/>
<xsl:template match="parametricsurface" mode="functions"/>

</xsl:stylesheet>
