<?xml version="1.0" encoding="ISO-8859-1"?>

<xsl:stylesheet xmlns:exslt="http://exslt.org/common" 
                xmlns:str="http://exslt.org/strings" 
		        xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
		        xmlns:tcl="http://xmllab.org/Tcl"
		        version="1.0" 
		        exclude-result-prefixes="exslt str">  
  
<xsl:template match="simulation" mode="web">

<tkml>

	  <xsl:choose>
    	<xsl:when test="($os='Linux') or ($os='SunOS') or ($os='Darwin')">
    	  <xsl:value-of select="concat('&#10;tk appname ',$appname)"/>
    	</xsl:when>
    	<xsl:when test="$os='Windows NT'">
    	  <xsl:value-of select="concat('&#10;package require dde;&#10;dde servername ',$appname)"/>
    	</xsl:when>
	  </xsl:choose>


	  <xsl:copy-of select="exslt:node-set($strings)/credits[@lang=$lang]"/>

	  <procedure name="output_html">
		<body>
			<write-html master="{$mastername}" name="{concat($outputdir,'/',$file,'.html')}">
					<head>  
						<title>
            	    		<xsl:value-of select="normalize-space(header/title[@lang=$lang])"/>
                		</title>
                        <link href="{concat('../',$css)}" rel="stylesheet" type="text/css"/>        
					</head>
                    <script>
                        <xsl:text>function itemselect()&#xA;{&#xA;</xsl:text>
                        <tcl:switch expr="$::section">
			                <xsl:for-each select="parameters/section">
                                <tcl:case value="{position()}">
                                    <xsl:apply-templates select="database" mode="onLoad"/>
                                </tcl:case>
                            </xsl:for-each>
			            </tcl:switch>
                         <xsl:text>}&#xA;</xsl:text>
                    </script>
					<body class="simulation">
						<xsl:attribute name="onLoad">itemselect()</xsl:attribute>
                        <table bgcolor="#b2b2b2" border="1" cellpadding="4" cellspacing="0" >
                            <tbody>
								<tr>
									<td colspan="2">
										<xsl:apply-templates select="header|notes" mode="web"/>
									</td>
								</tr>
	                            <tr>
                                    <td colspan="2">
                                        <img align="middle" src="../{$images}/puffin_logo_small.gif"/>
                                        <strong><xsl:value-of select="exslt:node-set($strings)/strings[@lang=$lang]/@scilabmessages"/> : </strong>
                                        <span style="color: red;">
                                            <xsl:for-each select="parameters//scalar|parameters//matrix">
	    	                                    <xsl:value-of select="concat('$::',@label,'_errortext')"/>
                                            </xsl:for-each>
                                            <xsl:text> $::scilab_message</xsl:text>
                                        </span>
                                    </td>
                                </tr>
                                 <tr>
                                   <td colspan="2">
                                        <!--<xsl:call-template name="form-link">
                                            <xsl:with-param name="type" select="'kill'"/>
                                            <xsl:with-param name="text" select="exslt:node-set($strings)/strings[@lang=$lang]/@quitdesc"/>
                                        </xsl:call-template>-->
                                        <xsl:call-template name="form-link">
                                            <xsl:with-param name="type" select="'download'"/>
                                            <xsl:with-param name="text" select="exslt:node-set($strings)/strings[@lang=$lang]/@downloadsource"/>
                                        </xsl:call-template>
                                        <xsl:call-template name="form-link">
                                            <xsl:with-param name="type" select="'saveSession'"/>
                                            <xsl:with-param name="text" select="exslt:node-set($strings)/strings[@lang=$lang]/@savesession"/>
                                        </xsl:call-template>
                                        <form name="loadSession" method="post" enctype="multipart/form-data" action="{$scriptname}"
                                              style="display:inline; margin-top: 0; margin-bottom: 0;">
		                                    <input type="hidden" name="source" value="{$sourcename}"/>
		                                    <input type="hidden" name="referer" value="{$referer}"/>
		                                    <input type="hidden" name="session" value="{$appname}"/>
		                                    <input type="hidden" name="type" value="loadSession"/>						
			                                    <a href="javascript:document.forms.loadSession.submit()">
                                                    <xsl:value-of select="exslt:node-set($strings)/strings[@lang=$lang]/@loadsession"/>
			                                    </a>
                                            <input type="file" name="sessionFile"/>
	                                    </form>                            
        	                        </td>
                                </tr>
                                <tr>                                  
                                    <xsl:variable name="nrow">
		                                <xsl:choose>
			                                <xsl:when test="parameters/actions">2</xsl:when>
			                                <xsl:otherwise>1</xsl:otherwise>
		                                </xsl:choose>
	                                </xsl:variable>
                                    <td rowspan="{$nrow}" valign="top">
                                     <table>
                                        <tbody>
                                            <tr><td>
                                            <xsl:if test="(parameters//point[@state!='hidden']) 
                                                 or (parameters//scalar[@state!='hidden']) 
                                                 or (parameters//matrix[@state!='hidden'])">
                                                    <xsl:apply-templates select="parameters" mode="web"/>
                                            </xsl:if>
                                            </td></tr>
                                            <xsl:if test="display/window[@editable='yes']">
                                                <tr>
                                                    <td>
                                                        <xsl:apply-templates select="display" mode="windowmenu"/>
                                                    </td>
                                                </tr>
                                            </xsl:if>
                                        </tbody>
                                     </table>
                                   </td>
                                   <xsl:apply-templates select="display" mode="web"/>
                                </tr>
     							<xsl:apply-templates select="parameters/actions" mode="web"/>
                            </tbody>
                        </table>
					</body>
			</write-html>

			<command>&#xA; catch {after cancel $::countdown_id}</command>

	        <command>
                <xsl:value-of select="concat('&#xA;set ::countdown_id [after 120000 {file delete ',$logfile,'; exit}]')"/>
            </command>		

	        <command>&#xA;set ::scilab_message " "</command>		
		</body>

	  </procedure>

      <procedure name="save_session" parms="savefile">
        <body>
        	<write-file dir="$::SESSIONDIR" name="$savefile" content="xml" type=".session">
    			<xsl:call-template name="save-xml-style-session"/>
    		</write-file>
        </body>
      </procedure>

      <procedure name="load_session" parms="loadfile">
       <body>
	    		<xslt input="$loadfile" stylesheet="[file join $::xmllab xsl loadsession.xsl]" output="Tcl"/>
	    </body>
      </procedure>

 	  <xsl:apply-templates select="parameters" mode="init"/>
 	  <xsl:apply-templates select="display" mode="init"/>

      <command>
        <set variable="web" value="yes"/>
        <set variable="imagesrefresh" value=""/>
		<set variable="section" value="1"/>
		<set variable="scilab_message" value=" "/>
        <xsl:choose>
            <xsl:when test="(parameters//point[@state!='hidden']) 
                                                 or (parameters//scalar[@state!='hidden']) 
                                                 or (parameters//matrix[@state!='hidden'])">
                
            		<set variable="menu" value="windows"/>
            </xsl:when>
            <xsl:otherwise>
                <set variable="menu" value="windows"/>
            </xsl:otherwise>
        </xsl:choose>
      </command>
	
    </tkml>

</xsl:template>


<xsl:template match="header/script" mode="web"/>
<xsl:template match="header/resource" mode="web"/>

<xsl:template name="form-link">
    <xsl:param name="type"/>
    <xsl:param name="text"/>
    <form name="{$type}" method="post" action="{$scriptname}" style="display: inline; margin-top: 0; margin-bottom: 0;">
		<input type="hidden" name="source" value="{$sourcename}"/>
		<input type="hidden" name="referer" value="{$referer}"/>
		<input type="hidden" name="session" value="{$appname}"/>
		<input type="hidden" name="type" value="{$type}"/>						
	    <a href="javascript:document.forms.{$type}.submit()">
            <xsl:value-of select="$text"/>
		</a>
        <xsl:text>&#160;&#160;&#160;</xsl:text>
	</form>
</xsl:template>

<xsl:template match="header" mode="web">
    <table width="100%" border="0">
    	<tr>
            <td>
			    <xsl:apply-templates mode="web"/>
			</td>
            <td align="right">
  
                <div class="logo">
                    <sup>XML</sup>lab version <xsl:value-of select="$xmllab-version"/><br/>http://xmllab.org
                </div>
        	</td>
    	</tr>
    </table>
</xsl:template>

<xsl:template match="header/title" mode="web">
	<xsl:if test="@lang=$lang">
        <h1>
			<xsl:value-of select="normalize-space(.)"/>
		</h1>
	</xsl:if>
</xsl:template>

<xsl:template match="header/image" mode="web">
    <img hspace="5" border="1" src="{concat('../',$webimages,'/',@href)}" align="left"/>
</xsl:template>


<xsl:template match="date" mode="web">
        <p>
		    <b>
		        <xsl:value-of select="concat(exslt:node-set($strings)/strings[@lang=$lang]/@date,' : ')"/>
            </b>
            <xsl:value-of select="."/>
        </p>
</xsl:template>

<xsl:template match="keywords" mode="web">
	<xsl:if test="@lang=$lang">
        <p>
		    <b>
		        <xsl:value-of select="concat(exslt:node-set($strings)/strings[@lang=$lang]/@keywords,' : ')"/>
            </b> 
            <xsl:value-of select="."/>        
        </p>
	</xsl:if>
</xsl:template>


<xsl:template match="author" mode="web">
    <p>
	    <b>
		    <xsl:value-of select="concat(exslt:node-set($strings)/strings[@lang=$lang]/@author,' : ')"/>
	    </b>
        <xsl:value-of select="."/>   
    </p>
</xsl:template>

<xsl:template match="notes" mode="web">
	<xsl:if test="@lang=$lang">
		<h3>Description</h3>
        <div style="width:500px;text-align:justify;">
    		<xsl:copy-of select="*"/>
        </div>
	</xsl:if>
</xsl:template>

<xsl:template match="parameters" mode="web">
	<xsl:variable name="nrow">
		<xsl:choose>
			<xsl:when test="actions">2</xsl:when>
			<xsl:otherwise>1</xsl:otherwise>
		</xsl:choose>
	</xsl:variable>
        <table>
            <tbody>
            <tr>
    	    <td valign="top" width="250px" rowspan="{$nrow}">
            <h2>
           	    <xsl:value-of select="exslt:node-set($strings)/strings[@lang=$lang]/@parameters"/>
       	    </h2>
		    <ul>
			    <xsl:apply-templates select="section" mode="parameters-menu"/>
		    </ul>
		    <form name="parameters" method="post" action="{$scriptname}">
			    <tcl:switch expr="$::section">
			        <xsl:apply-templates select="section" mode="web"/>
			    </tcl:switch>
		    </form>
        </td>
        </tr>
        </tbody>
        </table>
</xsl:template>

<xsl:template match="section" mode="web">
	<tcl:case value="{position()}">
		<input type="hidden" name="timing" value="{$timing}"/>
		<input type="hidden" name="referer" value="{$referer}"/>
		<input type="hidden" name="session" value="{$appname}"/>
		<input type="hidden" name="type" value="submit"/>						
		<xsl:apply-templates mode="web"/>
		<p align="center">
			<input value="{exslt:node-set($strings)/strings[@lang=$lang]/@rundesc}" type="submit"/>
		</p>
	</tcl:case>
</xsl:template>


<xsl:template match="section" mode="parameters-menu">
	<xsl:variable name="pos" select="position()"/>
	<li>
		<form name="parameters{position()}" method="post" action="{$scriptname}" style="margin-top: 0; margin-bottom: 0;">
			<input type="hidden" name="timing" value="{$timing}"/>
            <input type="hidden" name="referer" value="{$referer}"/>
			<input type="hidden" name="session" value="{$appname}"/>
			<input type="hidden" name="section" value="{position()}"/>			
			<input type="hidden" name="type" value="section"/>						
			<a class="selected[expr $::section=={position()}]" href="javascript:document.forms.parameters{position()}.submit()">
				<xsl:value-of select="title[@lang=$lang]"/>
			</a>
		</form>
	</li>
</xsl:template>


<xsl:template match="display" mode="web">
	<td valign="top">
        <h2>
            <xsl:value-of select="exslt:node-set($strings)/strings[@lang=$lang]/@windows"/>
        </h2>       
        <xsl:apply-templates mode="web"/>
    </td>
</xsl:template>

<xsl:template match="subsection" mode="web">
	<xsl:apply-templates mode="web"/>
</xsl:template>

<xsl:template match="group" mode="web">
	<xsl:apply-templates mode="web"/>
</xsl:template>

<xsl:template match="subsection/title" mode="web">
	<xsl:if test="@lang=$lang">
		<h4>
			<xsl:value-of select="normalize-space(.)"/>
		</h4>
	</xsl:if>
</xsl:template>

<xsl:template match="section/title" mode="web"/>

<xsl:template match="scalar" mode="web">
   <table border="1" cellpadding="4" cellspacing="0" width="60%" align="center">
   <thead align="center">
	<tr>
		<td colspan="2">
          <xsl:value-of select="concat(name[@lang=$lang],' ')"/>
		</td>
	</tr>
    </thead>
    <tbody>
    <tr>
	<td width="50%" align="right">
		<xsl:value-of select="concat(@label,' ')"/>
	</td>
	<td align="center" width="50%" style="background:white; font:10px">	
		<xsl:choose>
			<xsl:when test="ancestor::database">
				<xsl:value-of select="concat('$::',@label)"/>
			</xsl:when>
			<xsl:otherwise>
				<input style="font-size:10px; border:0px;" name="{@label}" value="$::{@label}" size="7"/>
			</xsl:otherwise>
		</xsl:choose>
	</td>
    </tr>
    </tbody>
    </table>
   <br/>
</xsl:template>

<xsl:template match="point[@state='hidden']" mode="web"/>

<xsl:template match="point" mode="web">
   <table border="1" cellpadding="4" cellspacing="0" width="70%" align="center">
   <thead align="center">
	<tr>
		<td colspan="4">
          <xsl:value-of select="concat(name[@lang=$lang],' ')"/>
		</td>
	</tr>
    </thead>
    <tbody>
    <tr >
    <td width="15%"><xsl:value-of select="concat(x1/@label,' ')"/></td>
	<td style="background:white; font-size:10px" width="35%" >	
	    <xsl:value-of select="concat('$::',x1/@label)"/>
    </td>
    <td width="15%"><xsl:value-of select="concat(x2/@label,' ')"/></td>
    <td style="background:white; font-size:10px" width="35%" >
        <xsl:value-of select="concat('$::',x2/@label)"/>
	</td>
    </tr>
    </tbody>
    </table>
   <br/>
</xsl:template>


<xsl:template match="scalar[@state='hidden']" mode="web">
	<input type="hidden" name="{@label}" value="$::{@label}"/>
</xsl:template>

<xsl:template match="matrix" mode="web">
	<xsl:variable name="class">
		<xsl:choose>
			<xsl:when test="@rows&gt;10">scrollablematrix</xsl:when>
			<xsl:otherwise>plainmatrix</xsl:otherwise>
		</xsl:choose>
	</xsl:variable>
	<div class="{$class}">
		<table border="1" cellpadding="4" cellspacing="0" align="center">
			<thead align="center">
				<tr>
                    <td colspan="{@cols}">
                        <xsl:value-of select="concat(name[@lang=$lang],' ')"/>
                    </td>
                </tr>
				<xsl:choose>
					<xsl:when test="col/name">
						<tr>
							<xsl:for-each select="col/name[@lang=$lang]">
								<td width="75px"><xsl:value-of select="."/></td>
							</xsl:for-each>
						</tr>
					</xsl:when>
				</xsl:choose>
			</thead>
			<tbody>
			     <xsl:call-template name="table-rows">
				     <xsl:with-param name="i" select="number(1)"/>
			     </xsl:call-template>
			</tbody>
		</table>
	</div>
	<br/>
</xsl:template>

<xsl:template name="table-rows">
	<xsl:param name="i"/>
	<tr>
		<xsl:call-template name="table-cols">
			<xsl:with-param name="j" select="number(1)"/>
			<xsl:with-param name="i" select="$i"/>
		</xsl:call-template>
	</tr>
	<xsl:if test="$i&lt;@rows">
		<xsl:call-template name="table-rows">
			<xsl:with-param name="i" select="$i+1"/>
		</xsl:call-template>
	</xsl:if>
</xsl:template>

<xsl:template name="table-cols">
	<xsl:param name="i"/>
	<xsl:param name="j"/>
	<td style="background:white;" width="50px" align="center">
		<xsl:choose>
			<xsl:when test="ancestor::database or @state='disabled'">
				<xsl:value-of select="concat('$::',@label,'(',$i,',',$j,')&#xA0;')"/>
			</xsl:when>
			<xsl:otherwise>
				<input style="10px; border:0px;" name="{@label}({$i},{$j})" value="$::{@label}({$i},{$j})" size="5"/>
			</xsl:otherwise>
		</xsl:choose>
	</td>		
	<xsl:if test="$j&lt;@cols">
		<xsl:call-template name="table-cols">
			<xsl:with-param name="j" select="$j+1"/>
			<xsl:with-param name="i" select="$i"/>
		</xsl:call-template>
	</xsl:if>

</xsl:template>

<xsl:template match="database" mode="web">
	<table border="1" cellpadding="4" cellspacing="0" align="center">
	    <thead>
	        <tr>
	            <td align="center">
	                <select name="{@label}_index" onChange="this.form.submit()"> 
		                <xsl:for-each select="record">
			                <option value="{position()}"><xsl:value-of select="name[@lang=$lang]"/></option>
		                </xsl:for-each>
	                </select>
	            </td>
	        </tr>
	    </thead>
	    <tbody>
		    <xsl:for-each select="*[not(self::record)]">
			    <tr>
				    <td>
					    <xsl:apply-templates select="." mode="web"/>
				    </td>
			    </tr>
		    </xsl:for-each>
	    </tbody>
	</table>
	<br/>
</xsl:template>

<xsl:template match="database" mode="onLoad">
	<xsl:value-of select="concat('document.parameters.',@label,'_index.options\[[expr $::',@label,'_index-1]\].selected=true;&#xA;')"/>
</xsl:template>

<xsl:template match="compute" mode="web"/>
<xsl:template match="graphs" mode="web"/>

<xsl:template match="display" mode="windowmenu">
        <hr/>
        <h2>
           	<xsl:value-of select="exslt:node-set($strings)/strings[@lang=$lang]/@windows"/>
       	</h2>
		<form name="display" method="post" action="{$scriptname}" style="margin-top: 0; margin-bottom: 0;">
			<input type="hidden" name="timing" value="{$timing}"/>
            <input type="hidden" name="referer" value="{$referer}"/>
			<input type="hidden" name="session" value="{$appname}"/>
			<input type="hidden" name="type" value="display"/>					
		    <table width="100%">
                <tbody>
                  <xsl:apply-templates select="window[@editable='yes']" mode="windowmenu"/>
                </tbody>
                <tfoot>
                    <tr>
                        <td align="center">            
                            <input value="{exslt:node-set($strings)/strings[@lang=$lang]/@update}" type="submit"/>
                        </td>
                    </tr>
                </tfoot>
            </table>
        </form>
</xsl:template>

<xsl:template match="window" mode="windowmenu">
    <xsl:apply-templates mode="windowmenu"/>
</xsl:template>


<xsl:template match="window/title" mode="windowmenu">
    <xsl:if test="@lang=$lang">
        <tr>
            <td>
                <h3>
                    <xsl:value-of select="."/>
               </h3>
            </td>
        </tr>
    </xsl:if>
</xsl:template>

<xsl:template match="window/axis2d" mode="windowmenu">
    <xsl:for-each select="drawcurve2d">
       <xsl:if test="key('graphs',@ref)/name[@lang=$lang]">
        <tr><td>
            <tcl:switch expr="$::display_{generate-id()}">
                <tcl:case value="on">              
                  <input type="checkbox" name="display_{generate-id()}" checked="ckecked"/>
                </tcl:case>
                <tcl:case value="off">
                    <input type="checkbox" name="display_{generate-id()}"/>
                </tcl:case>
            </tcl:switch>
            <input type="hidden" name="display_{generate-id()}" value="off"/>
            <xsl:value-of select="key('graphs',@ref)/name[@lang=$lang]"/>
        </td></tr>
       </xsl:if>
    </xsl:for-each>
    <tr><td/></tr>
    <tr><td/></tr>
</xsl:template>



<xsl:template match="window" mode="web">
	<xsl:apply-templates mode="web"/>	
	<form name="getpdf{position()}" method="post" action="{$scriptname}" style="margin-top: 0; margin-bottom: 0;">
		<input type="hidden" name="timing" value="{$timing}"/>
		<input type="hidden" name="referer" value="{$referer}"/>
		<input type="hidden" name="session" value="{$appname}"/>
		<input type="hidden" name="type" value="getpdf"/>
		<input type="hidden" name="window" value="{position()-1}"/>			
		<a class="selected1" href="javascript:document.forms.getpdf{position()}.submit()">
            <xsl:value-of select="exslt:node-set($strings)/strings[@lang=$lang]/@downloadpdf"/>
        </a>
	</form>
	<table ncols="1">
        <tbody>
        <tr>
            <td>
                <xsl:choose>
                    <xsl:when test="axis2d/drawpoints">
                        <form method="post" action="{$scriptname}" style="margin-top: 0; margin-bottom: 0;">
            		        <input type="hidden" name="timing" value="{$timing}"/>
			                <input type="hidden" name="referer" value="{$referer}"/>
			                <input type="hidden" name="session" value="{$appname}"/>
			                <input type="hidden" name="type" value="click"/>
			                <input type="hidden" name="window" value="{position()-1}"/>			
            		        <input type="image" name="click" hspace="5" border="0" src="{concat('../',$webimages,'/',$file,'_',$lang,'_',position(),'.png$::imagesrefresh')}" align="center"/>
                        </form>
                    </xsl:when>
                    <xsl:otherwise>
                        <!-- S'il y a un paramtre anim -->
                        <!-- et s'il y a des dpendances et que le paramtre anim en fait partie --> 
                        <!-- ou qu'il n' y pas d'attribut "dependencies" alors ici a peut tre une anim. flash -->
        		        <img hspace="5" border="0" src="{concat('../',$webimages,'/',$file,'_',$lang,'_',position(),'.png$::imagesrefresh')}" align="center"/>
                    </xsl:otherwise>
                </xsl:choose>
            </td>
        </tr>
    </tbody>
  </table>
</xsl:template>

<xsl:template match="window/title" mode="web">
	<xsl:if test="@lang=$lang">
		<h3>
			<xsl:value-of select="normalize-space(.)"/>
		</h3>
	</xsl:if>
</xsl:template>

<xsl:template match="actions" mode="web">
	<tr>
		<td valign="top">
			<h2><xsl:value-of select="title[@lang=$lang]"/></h2>
			<ul>
				<xsl:apply-templates select="*[not(self::title)]" mode="web"/>
			</ul>
		</td>
	</tr>
</xsl:template>

<xsl:template match="action" mode="web">
    <xsl:variable name="label">
      <xsl:choose>
        <xsl:when test="../@label">
          <xsl:value-of select="../@label"/>
        </xsl:when>
        <xsl:otherwise>
          <xsl:value-of select="concat('actions',generate-id(..))"/>
        </xsl:otherwise>
      </xsl:choose>
    </xsl:variable>  
	<li>	
		<form name="action{position()}" method="post" action="{$scriptname}" style="margin-top: 0; margin-bottom: 0;">
		    <input type="hidden" name="timing" value="{$timing}"/>
			<input type="hidden" name="referer" value="{$referer}"/>
			<input type="hidden" name="session" value="{$appname}"/>
			<input type="hidden" name="{$label}_index" value="{position()}"/>
			<input type="hidden" name="type" value="action"/>						
				<a class="selected0" href="javascript:document.forms.action{position()}.submit()">
					<xsl:value-of select="title[@lang=$lang]"/>
				</a>
		</form>
	</li>
</xsl:template>



<xsl:template match="axis2d" mode="web"/>
<xsl:template match="axis3d" mode="web"/>




</xsl:stylesheet>
