<?xml version="1.0" encoding="ISO-8859-1"?>

<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
xmlns:exslt="http://exslt.org/common">

<xsl:output method="xml" indent="yes" encoding="ISO-8859-1"/>

<xsl:param name="lang"/>
<xsl:param name="xmllab"/>

<xsl:variable name="version"><xsl:value-of select="document('version.xml')/xmllab/@version"/></xsl:variable>

<xsl:strip-space elements="*"/>

<xsl:template match="/">
	<xsl:apply-templates/>
</xsl:template>

<xsl:template match="publish">
  <demo_gateway>
  <script href="xmllab.dem.gateway.sce">
	<sciml>
			<body>
        <assign>
          <lhs>demopath</lhs>
          <rhs>
            <function-call name="strsubst">
              <inputs>
                <parm>
                  <function-call name="get_absolute_file_path">
                    <inputs><parm><string>xmllab.dem.gateway.sce</string></parm></inputs>
                  </function-call>
                </parm>
                <parm><string>\</string></parm>
                <parm><string>/</string></parm>
              </inputs>
             </function-call>
          </rhs>
        </assign>
				<assign>
					<lhs>subdemolist</lhs>
					<rhs>
						<list sep=";">
							<xsl:apply-templates select="category" mode="list-of-categories"/>
						</list>
					</rhs>
				</assign>
        <assign>
          <lhs><select matrix="subdemolist" row=":" col="2"/></lhs>
          <rhs>
            <concat>
                <arg>demopath</arg>
                <arg>
                  <select matrix="subdemolist" row=":" col="2"/>
                </arg>
            </concat>
          </rhs>
        </assign>
			</body>
	</sciml>
  </script>
 	<xsl:apply-templates select="category" mode="category-switch"/>
  </demo_gateway>
</xsl:template>

<xsl:template match="category" mode="list-of-categories">
	<parm>
    <list sep=",">
  		<parm><string><xsl:value-of select="name[@lang=$lang]"/></string></parm>
      <parm><string><xsl:value-of select="concat(@dir,'/',@dir,'.dem.gateway.sce')"/></string></parm>
    </list>
	</parm>
</xsl:template>

<xsl:template match="category" mode="category-switch">
  <script href="{concat(@dir,'/',@dir,'.dem.gateway.sce')}">
	<sciml>
			<body>
        <assign>
          <lhs>demopath</lhs>
          <rhs>
            <function-call name="strsubst">
              <inputs>
                <parm>
                  <function-call name="get_absolute_file_path">
                    <inputs><parm><string><xsl:value-of select="concat(@dir,'.dem.gateway.sce')"/></string></parm></inputs>
                  </function-call>
                </parm>
                <parm><string>\</string></parm>
                <parm><string>/</string></parm>
              </inputs>
             </function-call>
          </rhs>
        </assign>
				<assign>
					<lhs>subdemolist</lhs>
					<rhs>
						<list sep=";">
							<xsl:apply-templates select="simulations" mode="list-of-items"/>
						</list>
					</rhs>
				</assign>
        <assign>
          <lhs><select matrix="subdemolist" row=":" col="2"/></lhs>
          <rhs>
            <concat>
                <arg>demopath</arg>
                <arg>
                  <select matrix="subdemolist" row=":" col="2"/>
                </arg>
            </concat>
          </rhs>
        </assign>
			</body>
	</sciml>
  </script>	  
	<xsl:apply-templates select="simulations" mode="items"/>
</xsl:template>


<xsl:template match="simulations" mode="list-of-items">
		<xsl:apply-templates select="simulation[document(concat(ancestor::category/@dir,'/',@href),/)/simulation/header/title[@lang=$lang]]" mode="list-of-items"/>
</xsl:template>

<xsl:template match="simulation" mode="list-of-items">
	<parm>
    <list sep=",">		
      <parm>
        <string>
    			<xsl:value-of select="normalize-space(document(concat(ancestor::category/@dir,'/',@href),/)/simulation/header/title[@lang=$lang or (not (@lang))])"/>
		    </string>
    	</parm>
      <parm>
        <string>
             <xsl:value-of select="concat(@href,'.sce')"/>     
        </string>
      </parm>
    </list>
  </parm>
</xsl:template>

<xsl:template match="simulations" mode="items">
		<xsl:apply-templates select="simulation[document(concat(ancestor::category/@dir,'/',@href),/)/simulation/header/title[@lang=$lang]]" mode="items"/>
</xsl:template>

<xsl:template match="simulation" mode="items">
  <script href="{concat(ancestor::category/@dir,'/',@href,'.sce')}">
    <sciml>
      <macro-call name="xmllab">
			 <inputs>
				<parm><string>-run</string></parm>
				<parm><string>-lang</string></parm>
				<parm><string><xsl:value-of select="$lang"/></string></parm>
				<parm>
          <concat>
            <arg>demopath</arg>
            <arg><string><xsl:value-of select="concat('../../examples/',ancestor::category/@dir,'/',@href)"/></string></arg>
          </concat>
        </parm>
			 </inputs>
		 </macro-call>
    </sciml>
  </script>
</xsl:template>

</xsl:stylesheet>


