<?xml version="1.0" encoding="ISO-8859-1"?>

<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
xmlns:exslt="http://exslt.org/common">

<xsl:output method="xml" indent="no" encoding="ISO-8859-1"/>

<xsl:param name="lang"/>
<xsl:param name="xmllab"/>

<xsl:variable name="version"><xsl:value-of select="document('version.xml')/xmllab/@version"/></xsl:variable>

<xsl:strip-space elements="*"/>

<xsl:template match="/">
	<xsl:apply-templates/>
</xsl:template>

<xsl:template match="xmllab_menu">

	<sciml>

		<function-definition name="xmllab_menu">
			<inputs><parm>k</parm></inputs>
			<body>
        <macro-call name="global">
          <inputs>
            <parm><string>_lastpath</string></parm>
          </inputs>
        </macro-call>	
			  <switch expr="k">
          <case value="0">
           <macro-call name="addmenu">  
      			<inputs>
	      			<parm><string>XMLlab</string></parm>
		      		<parm>
			      		<list sep=";">
				      		<parm>
						      	<string><xsl:value-of select="strings[@lang=$lang]/@run"/></string>
					      	</parm>
						      <parm>
							      <string><xsl:value-of select="strings[@lang=$lang]/@edit"/></string>
			      			</parm>				
		      				<parm>
			      				<string><xsl:value-of select="strings[@lang=$lang]/@help"/></string>
		      				</parm>		
			      			<parm>
		      					<string><xsl:value-of select="strings[@lang=$lang]/@apropos"/></string>
			      			</parm>						
				      		<parm>
					      		<string><xsl:value-of select="strings[@lang=$lang]/@uninstall"/></string>
				      		</parm>						
					      </list>
			      	</parm>
		      		<parm>
			      		<function-call name="list">
				      		<inputs>
					      		<parm>2</parm>
					      		<parm><string>xmllab_menu</string></parm>
				      		</inputs>
				      	</function-call>
			    	</parm>
		     	  </inputs>
          </macro-call>
         </case>
         <case value="1">
						<assign>
							<lhs>path</lhs>
							<rhs>
								<function-call name="uigetfile">
									<inputs>
										<parm>file_mask=<string>*.xml</string></parm>
										<parm>_lastpath</parm>
										<parm>boxTitle=<string><xsl:value-of select="strings[@lang=$lang]/@run_dialog"/></string></parm>
									</inputs>
								</function-call>
							</rhs>
						</assign>
						<ifthenelse>
							<condition>path~=""</condition>
							<if>
								<assign>
									<lhs>_lastpath</lhs>
									<rhs>
										<function-call name="dirname">
											<inputs>
												<parm>path</parm>
											</inputs>
										</function-call>
									</rhs>
								</assign>								
								<macro-call name="xmllab">
									<inputs>
										<parm><string>-run</string></parm>
                    <parm>
  										<function-call name="strsubst">
                        <inputs>
                          <parm>path</parm>
                          <parm><string>\</string></parm> <!-- MSDOS and uigetfile... -->
                          <parm><string>/</string></parm>
                        </inputs>
                      </function-call>
                    </parm>
									</inputs>
								</macro-call>
							</if>
						</ifthenelse>
					</case>
					<case value="2">
						<assign>
							<lhs>path</lhs>
							<rhs>
								<function-call name="uigetfile">
									<inputs>
										<parm>file_mask=<string>*.xml</string></parm>
										<parm>_lastpath</parm>
										<parm>boxTitle=<string><xsl:value-of select="strings[@lang=$lang]/@edit_dialog"/></string></parm>
									</inputs>
								</function-call>
							</rhs>
						</assign>
						<ifthenelse>
							<condition>path~=""</condition>
							<if>
								<assign>
									<lhs>_lastpath</lhs>
									<rhs>
										<function-call name="dirname">
											<inputs>
												<parm>path</parm>
											</inputs>
										</function-call>
									</rhs>
								</assign>								
								<macro-call name="editor">
									<inputs>
										<parm>path</parm>
									</inputs>
								</macro-call>
							</if>
						</ifthenelse>
					</case>
					<case value="3">
						<macro-call name="help">
							<inputs><parm><string>xmllab</string></parm></inputs>
						</macro-call>
					</case>
					<case value="4">
						<macro-call name="messagebox">
							<inputs>
								<parm>
									<list sep=";">
										<xsl:for-each select="apropos[@lang=$lang]/string">
											<parm>
                        <string>
									  			<xsl:apply-templates/>
                        </string>
											</parm>
										</xsl:for-each>
									</list>
								</parm>
							</inputs>
						</macro-call>
					</case>
					<case value="5">
						<!-- Uninstall XMLlab -->
						<macro-call name="xmllab_uninstall">
							<inputs>
								<parm>
									<list sep=";">
										<xsl:for-each select="uninstall[@lang=$lang]/string">
											<parm>
                        <string>
												  <xsl:apply-templates/>
                       </string>
											</parm>
										</xsl:for-each>
										<parm>
										   <string>
                          <xsl:value-of select="strings[@lang=$lang]/@cancel"/>
                      </string>
										</parm>
									</list>
								</parm>
							</inputs>
						</macro-call>
					</case>
				</switch>
			</body>	
		</function-definition>
    
	</sciml>

</xsl:template>

<xsl:template match="xmllab-version">
  <xsl:value-of select="$version"/>
</xsl:template>


</xsl:stylesheet>


